;******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6250
;  *   	@Create Date         : 2020.01.09
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@֧QQȺ   	  : 814641858      
;  *    @΢ٷ̳   	  : http://bbs.sinomcu.com/	 
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------    	
;  *           	   	   	 ˣEVN1ѹ P15 
   	   	   	   	   	   	   	   	   	   	   	   	   	   	 
;      	   	   	   	   	ˣVIR 0.5V
;      	   	   	   	   	    P15>3.5V  CMPOF=0  	   	P11
;      	   	   	   	   	   	P15<3.5V  CMPOF=1      	 P11 
;      	   	   	   	   	   	עͻִ
;******************************************************************************
#include "MC30P6250.INC"

cblock 0x0010
abuf
statusbuf
endc

   	ORG     0x0000
   	goto   	MAIN
    ORG     0x8
   	goto   	INT_ISR	   	;ж

 
INT_ISR:

   	movra   abuf
   	swapar  STATUS
   	movra   statusbuf

   	JBSET  	T0IF
   	GOTO   	T0_END
   	JBSET  	T0IE
   	GOTO   	T0_END

   	BCLR   	T0IF
T0_END:

   	JBSET  	T1IF
   	GOTO   	T1_END
   	JBSET  	T1IE
   	GOTO   	T1_END

   	BCLR   	T1IF
T1_END:

   	JBSET  	CMPIE
   	GOTO   	CMP_END 
   	JBSET  	CMPIF
   	GOTO   	CMP_END

   	BCLR   	CMPIF
CMP_END:


   	swapar  statusbuf
   	movra   STATUS
   	swapr   abuf
   	swapar  abuf
END_OF_INTERRUPT
   	RETIE  	

MAIN:  	

   	CALL   	SYS_INTI
CMP_LOOP:

   	JBSET  	CMPOF
   	GOTO   	CMP_OUT            ;EVN1<3.5V
   	BSET   	P11D
   	GOTO   	CMP_LOOP
CMP_OUT:

   	BCLR   	P11D
   	GOTO   	CMP_LOOP
   	RETURN 	
 ; exit point of MAIN
 

SYS_INTI:

   	BCLR   	GIE
   	CALL   	CLR_RAM
   	CALL   	IO_INTI
   	CALL   	CMP_INTI
   	BSET   	GIE
   	RETURN 	
 ; exit point of SYS_INTI
 

CMP_INTI:
   	   	  
   	MOVAI  	0x90
   	MOVRA  	CMPCR0                  ;EVN1P15  P12     	   
   	MOVAI  	0x2A
   	MOVRA  	CMPCR1                  ;3.5V 
   	RETURN 	
 ; exit point of CMP_INTI
 

IO_INTI:

	CLRR	P1
	MOVAI	0x20
	MOVRA	DDR1		;1:input 0:output  P15

   	MOVAI  	0xff
   	MOVRA  	PUCON                  ;0:Effective 1:invalid
   	MOVRA  	PDCON                  ;0:Effective 1:invalid
   	CLRR   	ODCON                  ;0:  1:©
   	RETURN 	    
 ; exit point of IO_INTI
 

CLR_RAM:

   	movai 0x40
   	movra FSR
   	movai 48
   	movra 0x07
   	decr FSR
   	clrr INDF
   	djzr 0x07
   	goto $ -3;
   	clrr 0x07
   	RETURN 	
 ; exit point of CLR_RAM
 
 
   	end

