;******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6250
;  *   	@Create Date         : 2020.01.09
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@֧QQȺ   	  : 814641858      
;  *    @΢ٷ̳   	  : http://bbs.sinomcu.com/	 
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------    	
;  *           	   	   	 T0 1S P12תһΣ
;******************************************************************************
#include "MC30P6250.INC"

cblock 0x0010
abuf
statusbuf
endc

   	ORG     0x0000
   	goto   	MAIN
    ORG     0x8
   	goto   	INT_ISR	   	;ж

 
INT_ISR:

   	movra   abuf
   	swapar  STATUS
   	movra   statusbuf

   	JBSET  	T0IF
   	GOTO   	T0_END
   	JBSET  	T0IE
   	GOTO   	T0_END
   	BCLR   	T0IF
   	MOVAI  	127
   	MOVRA  	T0CNT
T0_END:

   	swapar  statusbuf
   	movra   STATUS
   	swapr   abuf
   	swapar  abuf
END_OF_INTERRUPT
   	RETIE  	


MAIN:

   	CALL   	SYS_INIT
SLEEP_LOOP:
;  	.line  	83; "MC30P6250_C.c"	GIE = 0;   	   	//رж
   	BCLR   	GIE                     ;رж
    NOP
    NOP
    STOP                            ;
    NOP
    NOP
   	BSET   	GIE                     ;ж
    MOVAI  	00000100B
   	XORRA  	P1                      ;P12 ת
   	GOTO   	SLEEP_LOOP
   	RETURN 	
; exit point of MAIN

SYS_INIT:

   	BCLR   	GIE                     ;رж
   	CALL   	CLR_RAM
   	CALL   	IO_INIT
   	CALL   	TIMER0_RTC_INIT
   	BSET   	GIE                     ;ж
   	RETURN 	
; exit point of SYS_INIT


TIMER0_RTC_INIT:

   	MOVAI  	0x07
   	MOVRA  	T0CR                    ;256 
   	MOVAI  	127
   	MOVRA  	T0CNT                   ;
   	MOVAI  	0x80
   	MOVRA  	TM0CR                   ;Ƶϵͳʱ
   	BCLR   	T0IF
   	BSET   	T0IE
   	RETURN 	
; exit point of TIMER0_RTC_INIT


IO_INIT:

   	CLRR   	P1                      ;1:input 0:output
   	CLRR  	DDR1                    ;1:input 0:output
   	MOVAI  	0xff
   	MOVRA  	PUCON                   ;0:Effective 1:invalid
   	MOVRA  	PDCON                   ;0:Effective 1:invalid      
   	CLRR   	ODCON                   ;0:  1:©
   	RETURN 	
; exit point of IO_INIT


CLR_RAM:
   	movai 0x40
   	movra FSR
   	movai 48
   	movra 0x07
   	decr FSR
   	clrr INDF
   	djzr 0x07
   	goto $ -3;
   	clrr 0x07
   	
   	RETURN 	
; exit point of CLR_RAM

   	end


